2008-09-10 v.2.0.8.1
--------------------
- BUGFIX: possilbe security issue fixed in file class/theme.class.php

2008-08-29 v.2.0.8
------------------
- FEATURE ADDED: read-only mode. turn read-only mode on by calling 
  $editor->setReadOnly() prior to show()
- BUGFIX: when inserting anchor on an empty content in Firefox inner document 
  URL was inserted into editing area
- BUGFIX: paragraph value Normal wasn't working in Firefox. Replaced with <p> 
  in config.default.php (replace in your config.php if you are affected)

2008-04-04 v.2.0.7
------------------
- FEATURE ADDED: when inserting a hyperlink and nothing is selected, hyperlink 
  title is used for linked text (if title is not set href url is used)
- CHANGE: reworked CSS class application algorithm: now if nothing is selected 
  CSS class is set on the parent tag of the current cursor position, plus style 
  changes are applied to the same span tag rather than creating a new one
- CHANGE: font name and font sizes are now applied with custom code rather than 
  browser features allowing for wider variety of valid settings
- CHANGE: JavaScript API: refactored style setting methods: moved style setting 
  to editor methods applyStyleToSelection and removeStyleFrom, so they could be 
  called from various other methods (like font settings, etc.)
- BUGFIX/WORKAROUND: empty paragraphs were multiplying in IE when DOM tree or 
  HTML had paragraph inside of a paragraph
- BUGFIX/WORKAROUND: when content started with script or style tag it was 
  removed under IE
- BUGFIX: there were PHP notices in dialogs when session wasn't used to store 
  config data
- BUGFIX: inner contents of style tag was stripped under IE
- BUGFIX: insertHtmlAtSelection method wasn't working correctly in IE when 
  "control" (image, etc.) was selected
- BUGFIX: SpawFm plugin: fixed automatic uploaded file/created directory selection
- LANGUAGE FILE ADDED: Romanian (Lari Corifeanu)
- LANGUAGE FILE ADDED: SpawFM: Turkish (Sitki Ozkurt)
- LANGUAGE FILE ADDED: core and SpawFM: Celtic (Alan Davies)
- LANGUAGE FILE ADDED: SpawFM: Slovak (Martin Svec)
- LANGUAGE FILE UPDATED: Slovak (Martin Svec)
- LANGUAGE FILE UPDATED: Italian (fabrix)

2007-12-20 v.2.0.6
------------------
- FEATURE ADDED: Quick links in hyperlink dialog
- FEATURE ADDED: CSS class in image properties dialog
- BUGFIX: fixed (hopefully) long-standing bug with content doubling under IE in
  some invalid HTML cases
- BUGFIX: calls to getPageHtml were destroying DOM tree
- BUGFIX: in some cases <br /> was multiplying empty lines in source code under 
  Firefox
- BUGFIX: html mode textareas where set to zero width when switching between tabs
- BUGFIX: spaces between tags were completely removed
- BUGFIX: inputName variable name was mistyped in editor.class.php
- BUGFIX: SpawFm plugin: fixed uploaded image height checking
- BUGFIX: SpawFm plugin: fixed failing files listing when current directory has 
  a single quote in it's name
- CHANGE: SpawFm plugin: files/directories list sorting changed from sort() to 
  natcasesort()
- LANGUAGE FILE UPDATED: German (Martina Greiner)
- LANGUAGE FILE UPDATED: Bulgarian (Stoyan Dimitrov)
- LANGUAGE FILE UPDATED: French
- LANGUAGE FILE UPDATED: Czech (Radek Uhlir)
- LANGUAGE FILE UPDATED: Finnish (Teemu Joensuu)
- LANGUAGE FILE UPDATED: Arabic (Mohammed Ahmed)
- LANGUAGE FILE ADDED: SpawFM: Bulgarian (Stoyan Dimitrov)
- LANGUAGE FILE ADDED: SpawFM: Arabic (Mohammed Ahmed)
- LANGUAGE FILE ADDED: Spaw FM: Finish (Teemu Joensuu)

2007-07-16 v.2.0.5
------------------
- BUGFIX: text direction wasn't set in dialogs when using RTL languages like 
  Hebrew and Arabic

2007-06-21 v.2.0.5 Beta
-----------------------
- FEATURE ADDED: support for Safari 3 browser on OS X and Windows
- BUGFIX: absolute URLs were not stripped in XHTML module
- BUGFIX: XHTML rendering: only the first instance of & in href and src 
  attributes was converted to &amp;

2007-06-11 v.2.0.4.1
--------------------
- BUGFIX: XHTML rendering: closing quotes were lost on href and src attributes. 
  Href attribute was incorrectly added to img tags under IE

2007-06-06 v.2.0.4
------------------
- FEATURE ADDED: SpawFm plugin: added settings ("forbid_extensions", 
  "forbid_extensions_strict") to disallow uploading insecure files;
- FEATURE ADDED: added "page_body" to event subsystem to add events to page's 
  body object
- BUGFIX (workaround): SPAW's status bar functionality was causing problems with
  undo/redo functions under IE. Status bar functionality (as least important of 
  the two) is now disabled under IE until we find a complete solution
- BUGFIX: css classes for table cells dialog were not loaded
- BUGFIX: shape and coords attributes were lost in area tag under IE
- BUGFIX: dialog window resize was incorrect on some smaller display resolutions
  with IE7
- BUGFIX: only first instances of &, < and > in a single text node where 
  properly encoded
- BUGFIX: SpawFm plugin: fixed files filtering by selected filetype
- FIX: when using toolbar buttons in Firefox focus wasn't returned back to 
  editing area so that you can type further without clicking inside the 
  editing area first
- FIX: & in href and src attributes is now replaced with &amp;
- FIX: added rows and cols attributes on textarea
- FIX: added ALT attribute on resizing grip
- FIX: converted all attribute names to lowercase on toolbar buttons
- FIX: added empty alt attribute to toolbar images
- FIX: alt attribute is always added to img tag in image properties dialog
- FIX: added empty ALT attribute to image tag on quick image insert
- LANGUAGE FILE ADDED: SpawFM: French (mehdi cherifi)
- LANGUAGE FILE ADDED: SpawFM: Italian
- LANGUAGE FILE ADDED: SpawFM: German (Alexander Schmutz)
- LANGUAGE FILE ADDED: SpawFM: Czech (Kristian Vrhel)
- LANGUAGE FILE UPDATED: Brazilian Portuguese (Alessandro Gambin da Silva)
- LANGUAGE FILE UPDATED: Czech (Kristian Vrhel)
- LANGUAGE FILE UPDATED: Hungarian (Szentgyörgyi J?nos)
- LANGUAGE FILE UPDATED: Spanish (Ing. Martin Perez)
- DOCS: added note about session_start to integrators guide


2007-03-15 v.2.0.3
------------------
- FEATURE ADDED: optional feature to convert special characters to respectable 
  html entities like &copy; etc.
- FEATURE ADDED: added a feature to quickly insert an image (in SPAW 1.x style)
- FEATURE ADDED: predefined colors in color picker dialog could be customized
- BUGFIX: removed unnecessary empty lines at the end of most language files
- BUGFIX: numbered list items where rendered with value="-1" under Firefox
- BUGFIX: SpawFm plugin: removed empty spaces in the end of include files
- BUGFIX: under Gecko content area wasn't editable after the first load when 
  working over HTTPS
- BUGFIX: additional bugfix for https under firefox issue: images were rendered 
  as broken in editor
- BUGFIX: SpawFm plugin: files were not listed when using HTTPS with Firefox
- BUGFIX: SPAW usurped document's mousemove and mouseup events
- COSMETIC FIX: removed extra quote from the dialog_footer.tpl in spaw2 theme


2007-02-19 v.2.0.2
------------------
- FEATURE ADDED: SpawFm plugin: when "fsdir" parameter is set, "dir" parameter 
  can be set to absolute URL
- FEATURE ADDED: added semi-automatic path calculation to config file which 
  could be used if fully automatic algorithm fails
- FEATURE ADDED: added preformatted, address and paragraph (<p>) options to 
  default paragraph dropdown option list
- BUGFIX: when applying a hyperlink to selected image the image was removed 
  under IE
- BUGFIX: strings like $xx (where xx - some digits) were treated by the editors 
  PHP code as regex back references and stripped from the content
- BUGFIX: background color setting in default wysiwyg.css file was preventing 
  displaying of background color settings on tables and table cells
- BUGFIX: 1.x compatibility mode: unnecessary default values for width and 
  height removed, default (set in config file) theme will be always used in 
  compatibility mode
- BUGFIX: delete/backspace didn't work under Gecko until user typed something
- BUGFIX: CSS classes were not applied to toolbar items when defined in themes
- BUGFIX: SpawFm plugin: DOCUMENT_ROOT was used in sample 'fs_dir' parameter, 
  replaced with SPAW_ROOT
- BUGFIX: SpawFm plugin: use of undefined variable
- BUGFIX: added line breaks at the end of browser specific editor.js files. This 
  was causing javascript errors in some environments.
- COSMETIC FIX: spaw2 theme was rendered with cosmetic glitch when used in 
  XHTML 1.1 page
- LANGUAGE FILE ADDED: SpawFm plugin: Lithuanian
- LANGUAGE FILE ADDED: SpawFm plugin: Russian
- LANGUAGE FILE ADDED: SpawFm plugin: Dutch (Floris Brant)


2007-01-24 v.2.0.1
------------------
- FEATURE ADDED: SpawFm plugin: browse/create/rename/delete subdirectories
- FEATURE ADDED: SpawFm plugin: rename files (file extensions cannot be changed
  except case)
- FEATURE ADDED: SpawFm plugin: optional 'fsdir' parameter to specify absolute 
  filesystem path to directory
- FEATURE ADDED: SpawFm plugin: files list sorted by name
- FEATURE ADDED: implemented constrain proportions feature in image properties 
  dialog
- FEATURE ADDED: image preview in image properties dialog
- FEATURE ADDED: added insertHtmlAtSelection() API method which inserts 
  specified string
- FEATURE ADDED: added selectionWalk API function allowing to specify a function
  which would be called on every node in current selection
- BUGFIX: "Access denied" error occurred on loading in some installations of IE6
- BUGFIX: specifying toolbarset as a parameter to constructor resulted in PHP 
  error
- BUGFIX: added code to dialog.php to check if the session has already been 
  started (in case it's autostarted on the server)
- BUGFIX: SPAW was stealing focus under IE when page loads
- BUGFIX: background image button wasn't working in table and table cell 
  properties dialogs
- BUGFIX: focus wasn't set to the currently visible editing area when switching
  between html/design modes which caused minor problems in IE
- BUGFIX: absolute urls were not correctly stripped if the url was below spaw's 
  directory (moved empty.html into it's own directory)
- BUGFIX: SpawFm plugin: use full URL for images preview
- BUGFIX: removed onfocus event handler from iframe's because it was called 
  constantly in IE in floating toolbar mode
- BUGFIX: toolbar wasn't correctly positioned in floating mode under Gecko when 
  document was with xhtml doctype
- BUGFIX: enctype attribute was lost on FORM tags
- BUGFIX: value and type attributes were lost on input tags under IE 
  (type="text" only)
- IMPROVEMENT: added window.focus() to dialogs to activate dialogs when they 
  load or when returning from other dialogs (like file manager)
- IMPROVEMENT: when returning from one dialog to another (like from file manager
  to image properties) focus is set to appropriate field
- IMPROVEMENT: OK button is now triggered by pressing enter in dialogs
- COSMETIC IMPROVEMENT: optimized dialog resizing algorithm a little (so there's
  a little less flickering under IE and Opera)
- COSMETIC IMPROVEMENT: dialogs are resized and centered only when they open 
  (when navigating through directories in file manager it won't resize and 
  center)
- COSMETIC IMPROVEMENT: hyperlink dialog wasn't sized properly
- COSMETIC IMPROVEMENT: dialogs open centered


2007-01-09 v.2.0.0
------------------
- FEATURE ADDED: font tags replaced with span equivalents in xhtml rendering mode
- FEATURE ADDED: SpawFm plugin: automatically select uploaded file
- FEATURE ADDED: SpawFm plugin: allow specifying max width and/or height 
  for uploaded images
- FEATURE ADDED: SpawFm plugin: 'chmod_to' setting allows to specify what mode 
  the uploaded file should be tried to chmod to.
- FEATURE ADDED: added SpawDialog.returnValue method which handles callback 
  function calls in dialogs
- FEATURE ADDED: added trimLineBreaks and htmlEncode methods to SpawUtils
- CHANGE: changed SPAW v.1 compatibility code to use default theme instead of 
  SPAW1 (spaw1 theme will be available as a separate download only)
- BUGFIX: spaw2 theme css file had reference to non-existing and not needed 
  toolbar background image
- BUGFIX: in some cases line breaks in code were multiplying under Gecko
- BUGFIX: removed some unnecessary page hidding and showing calls under Gecko
- BUGFIX: context menu was incorrectly positioned under Gecko when used inside 
  XHTML doctype documents
- BUGFIX: some Flash (embed) attributes were lost while switching between 
  design/html modes (should still use embed tags for flash rather than object 
  because IE loses embed inside object tag and doesn't handle object right in 
  wysiwyg mode)
- BUGFIX: Flash placeholder image wasn't always displayed under Gecko
- BUGFIX: horizontal rule was inserted in IE with id="null"
- BUGFIX: images under MSIE: images where sometimes inserted in the parent 
  document, image property editing produced errors, image properties where 
  unavailable from context menu
- BUGFIX: added ALT attributes to img tags in theme templates
- BUGFIX: SpawFm plugin: <?= replaced with <?php echo
- BUGFIX: editor wasn't correctly resized when making it smaller under Gecko 
  and spaw2 theme
- BUGFIX: all attributes except class and style were stripped from span, div 
  and font tags
- BUGFIX: SpawFm plugin: variable name mistype
- LANGUAGE FILE ADDED: Dutch
- LANGUAGE FILES ADDED: ported language files from SPAW v.1
- TWEAK: added some CSS properties to theme stylesheets to protect parent page 
  styles from interfering with SPAW's interface
- DOCUMENT ADDED: plugin developer's guide


2006-12-19 v.2.0.0 RC
---------------------
- FEATURE ADDED: config variable 'base_href' added to specify protocol and 
  domain part to be added to urls returned from file manager (use in conjunction 
  with strip_absolute_urls = false)
- FEATURE ADDED: SpawFm plugin returns full file URL if config variable 
  'base_href' is specified and is not empty
- FEATURE ADDED: browse button in hyperlink dialog to insert links to files
- FEATURE ADDED: SpawFm plugin keyboard navigation
- FEATURE ADDED: added setStaticConfigValueElement, getStaticConfigValueElement, 
  getConfigValueElement, setConfigValueElement methods to config and editor 
  classes
- FEATURE ADDED/BUGFIX: editor/page names now can contain square brackets 
  ([ and ])
- OPTIMIZATION: updateToolbar now only checks toolbar item status/value if it's 
  enabled
- CHANGE: changed default resizing direction in config file to "vertical"
- CHANGE: disabled file upload button is shown in SpawFm plugin if upload is
  not allowed
- BUGFIX: if submit() method was used on a submit type control (input type=
  submit or type=image) this often resulted in lost content
- BUGFIX: form onsubmit event handler was added multiple times if there were  
  more than 1 editor instance resulting in unexpected HTML rendering results
- BUGFIX: editor was unusable in Internet Explorer when inserted into page with 
  XHTML doctype declaration
- BUGFIX: editing area wasn't editable in Mozilla (and probably older versions 
  of Firefox)
- BUGFIX: custom_tbi_css_events used where custom_tbi_events was assumed
- BUGFIX: SpawLang->getLang was just a copy of setLang
- BUGFIX: when moving focus to other editor in Gecko active editor wasn't set
- BUGFIX: javascript error was generated in Opera when inserting at the end of 
  document
- BUGFIX: in xhtml beautification process br tag wasn't generating new line and 
  indentation
- BUGFIX: extra quote in one tag in SPAW2 theme templates
- BUGFIX: flash wasn't properly rendered in html under IE
- BUGFIX: flash wasn't replaced with placeholder images on initialization
- BUGFIX: in Gecko based browsers disabled buttons were still clickable
- BUGFIX: Javascript error on iframe focus in SpawFm Plugin
- BUGFIX: content wasn't always correctly inserted under Gecko and Opera
- BUGFIX: php notice in SpawFm plugin
- BUGFIX: text wasn't properly html encoded when rendered to HTML
- BUGFIX: updated xhtml rendering engine: empty paragraphs were rendered without 
  &nbsp; under IE, useless empty elements removed (b, i, etc.)
- BUGFIX: added indentation for ul, ol, li, thead, tfoot tags
- BUGFIX: added default_output_charset config variable, dialogs now use user 
  specified output charset, modified setLanguage method to accept output charset 
  as a second parameter
- BUGFIX: '.' and '..' directories were shown in SpawFm plugin
- BUGFIX: some execCommand related calls were throwing exceptions under Gecko
- LANGUAGE FILE ADDED: Hungarian (Szentgyörgyi J?nos, www.dynamicart.hu)


2006-12-06 v.2.0.0 Beta
-----------------------
- First public v.2 release
